VERSION 5.00
Begin VB.UserControl WComboBox 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "WComboBox.ctx":0000
   Begin VB.ComboBox cboCombo 
      Height          =   315
      Left            =   1200
      TabIndex        =   0
      Text            =   "Combo1"
      Top             =   1440
      Width           =   2415
   End
End
Attribute VB_Name = "WComboBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'Default Property Values:
Const m_def_LimitToList = 0
'Property Variables:
Dim m_LimitToList As Boolean
'Event Declarations:
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=cboCombo,cboCombo,-1,KeyDown
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Event KeyPress(KeyAscii As Integer) 'MappingInfo=cboCombo,cboCombo,-1,KeyPress
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=cboCombo,cboCombo,-1,KeyUp
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Event Change() 'MappingInfo=cboCombo,cboCombo,-1,Change
Attribute Change.VB_Description = "Occurs when the contents of a control have changed."
Event DropDown() 'MappingInfo=cboCombo,cboCombo,-1,DropDown
Attribute DropDown.VB_Description = "Occurs when the list portion of a ComboBox control is about to drop down."
'True if FindItem is running
Private bFinding As Boolean

'Current cursor position within the text
Private lPos As Long

'Index value of the last item selected
Private lIndex As Long

Private Sub FindItem()

  Dim lIdx As Long
  Dim sText As String
  Dim lLen As Long
  Dim bFound As Boolean
  
  bFinding = True
  lPos = cboCombo.SelStart
  sText = cboCombo.Text
  lLen = Len(sText)
  bFound = False
  
  For lIdx = 0 To cboCombo.ListCount
    If StrComp(sText, Left$(cboCombo.List(lIdx), lLen), vbTextCompare) = 0 Then
      cboCombo.ListIndex = lIdx
      bFound = True
      Exit For
    End If
  Next lIdx
  
  If m_LimitToList And Not bFound Then
    cboCombo.ListIndex = lIndex
      If lIndex = -1 Then cboCombo.Text = ""
      cboCombo.SelStart = lPos - 1
  Else
    cboCombo.SelStart = lPos
    lIndex = cboCombo.ListIndex
  End If

  cboCombo.SelLength = Len(cboCombo.Text)
  bFinding = False

End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = cboCombo.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    cboCombo.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = cboCombo.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    cboCombo.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = cboCombo.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    cboCombo.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = cboCombo.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set cboCombo.Font = New_Font
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
    cboCombo.Refresh
End Sub

Private Sub cboCombo_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub cboCombo_KeyPress(KeyAscii As Integer)
    
  If KeyAscii = 8 Then
    bFinding = True
    cboCombo.SelText = ""
    bFinding = False
  End If
    
  RaiseEvent KeyPress(KeyAscii)

End Sub

Private Sub cboCombo_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,AddItem
Public Sub AddItem(ByVal Item As String, Optional ByVal Index As Variant)
Attribute AddItem.VB_Description = "Adds an item to a Listbox or ComboBox control or a row to a Grid control."
    cboCombo.AddItem Item, Index
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,Appearance
Public Property Get Appearance() As Integer
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
    Appearance = cboCombo.Appearance
End Property

Public Property Let Appearance(ByVal New_Appearance As Integer)
    cboCombo.Appearance() = New_Appearance
    PropertyChanged "Appearance"
End Property

Private Sub cboCombo_Change()
    
  If bFinding Then Exit Sub
  If Len(cboCombo.Text) = 0 Then
    lPos = 0
    lIndex = -1
  Else
    FindItem
  End If
    
  RaiseEvent Change

End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,Clear
Public Sub Clear()
Attribute Clear.VB_Description = "Clears the contents of a control or the system Clipboard."
    cboCombo.Clear
End Sub

Private Sub cboCombo_DropDown()
    RaiseEvent DropDown
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,FontBold
Public Property Get FontBold() As Boolean
Attribute FontBold.VB_Description = "Returns/sets bold font styles."
    FontBold = cboCombo.FontBold
End Property

Public Property Let FontBold(ByVal New_FontBold As Boolean)
    If Ambient.UserMode = False Then Err.Raise 382
    cboCombo.FontBold() = New_FontBold
    PropertyChanged "FontBold"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,FontItalic
Public Property Get FontItalic() As Boolean
Attribute FontItalic.VB_Description = "Returns/sets italic font styles."
    FontItalic = cboCombo.FontItalic
End Property

Public Property Let FontItalic(ByVal New_FontItalic As Boolean)
    If Ambient.UserMode = False Then Err.Raise 382
    cboCombo.FontItalic() = New_FontItalic
    PropertyChanged "FontItalic"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,FontName
Public Property Get FontName() As String
Attribute FontName.VB_Description = "Specifies the name of the font that appears in each row for the given level."
    FontName = cboCombo.FontName
End Property

Public Property Let FontName(ByVal New_FontName As String)
    If Ambient.UserMode = False Then Err.Raise 382
    cboCombo.FontName() = New_FontName
    PropertyChanged "FontName"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,FontSize
Public Property Get FontSize() As Single
Attribute FontSize.VB_Description = "Specifies the size (in points) of the font that appears in each row for the given level."
    FontSize = cboCombo.FontSize
End Property

Public Property Let FontSize(ByVal New_FontSize As Single)
    If Ambient.UserMode = False Then Err.Raise 382
    cboCombo.FontSize() = New_FontSize
    PropertyChanged "FontSize"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,FontStrikethru
Public Property Get FontStrikethru() As Boolean
Attribute FontStrikethru.VB_Description = "Returns/sets strikethrough font styles."
    FontStrikethru = cboCombo.FontStrikethru
End Property

Public Property Let FontStrikethru(ByVal New_FontStrikethru As Boolean)
    If Ambient.UserMode = False Then Err.Raise 382
    cboCombo.FontStrikethru() = New_FontStrikethru
    PropertyChanged "FontStrikethru"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,FontUnderline
Public Property Get FontUnderline() As Boolean
Attribute FontUnderline.VB_Description = "Returns/sets underline font styles."
    FontUnderline = cboCombo.FontUnderline
End Property

Public Property Let FontUnderline(ByVal New_FontUnderline As Boolean)
    If Ambient.UserMode = False Then Err.Raise 382
    cboCombo.FontUnderline() = New_FontUnderline
    PropertyChanged "FontUnderline"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,hWnd
Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle (from Microsoft Windows) to an object's window."
    hWnd = cboCombo.hWnd
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,List
Public Property Get List(ByVal Index As Integer) As String
Attribute List.VB_Description = "Returns/sets the items contained in a control's list portion."
    List = cboCombo.List(Index)
End Property

Public Property Let List(ByVal Index As Integer, ByVal New_List As String)
    cboCombo.List(Index) = New_List
    PropertyChanged "List"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,ItemData
Public Property Get ItemData(ByVal Index As Integer) As Long
Attribute ItemData.VB_Description = "Returns/sets a specific number for each item in a ComboBox or ListBox control."
    ItemData = cboCombo.ItemData(Index)
End Property

Public Property Let ItemData(ByVal Index As Integer, ByVal New_ItemData As Long)
    cboCombo.ItemData(Index) = New_ItemData
    PropertyChanged "ItemData"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,ListCount
Public Property Get ListCount() As Integer
Attribute ListCount.VB_Description = "Returns the number of items in the list portion of a control."
    ListCount = cboCombo.ListCount
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,ListIndex
Public Property Get ListIndex() As Integer
Attribute ListIndex.VB_Description = "Returns/sets the index of the currently selected item in the control."
    ListIndex = cboCombo.ListIndex
End Property

Public Property Let ListIndex(ByVal New_ListIndex As Integer)
    If Ambient.UserMode = False Then Err.Raise 382
    cboCombo.ListIndex() = New_ListIndex
    PropertyChanged "ListIndex"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,Locked
Public Property Get Locked() As Boolean
Attribute Locked.VB_Description = "Determines whether a control can be edited."
    Locked = cboCombo.Locked
End Property

Public Property Let Locked(ByVal New_Locked As Boolean)
    cboCombo.Locked() = New_Locked
    PropertyChanged "Locked"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
    Set MouseIcon = cboCombo.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set cboCombo.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,MousePointer
Public Property Get MousePointer() As Integer
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    MousePointer = cboCombo.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As Integer)
    cboCombo.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,NewIndex
Public Property Get NewIndex() As Integer
Attribute NewIndex.VB_Description = "Returns the index of the item most recently added to a control."
    NewIndex = cboCombo.NewIndex
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,RemoveItem
Public Sub RemoveItem(ByVal Index As Integer)
Attribute RemoveItem.VB_Description = "Removes an item from a ListBox or ComboBox control or a row from a Grid control."
    cboCombo.RemoveItem Index
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,SelLength
Public Property Get SelLength() As Long
Attribute SelLength.VB_Description = "Returns/sets the number of characters selected."
    SelLength = cboCombo.SelLength
End Property

Public Property Let SelLength(ByVal New_SelLength As Long)
    If Ambient.UserMode = False Then Err.Raise 382
    cboCombo.SelLength() = New_SelLength
    PropertyChanged "SelLength"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,SelStart
Public Property Get SelStart() As Long
Attribute SelStart.VB_Description = "Returns/sets the starting point of text selected."
    SelStart = cboCombo.SelStart
End Property

Public Property Let SelStart(ByVal New_SelStart As Long)
    If Ambient.UserMode = False Then Err.Raise 382
    cboCombo.SelStart() = New_SelStart
    PropertyChanged "SelStart"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,SelText
Public Property Get SelText() As String
Attribute SelText.VB_Description = "Returns/sets the string containing the currently selected text."
    SelText = cboCombo.SelText
End Property

Public Property Let SelText(ByVal New_SelText As String)
    If Ambient.UserMode = False Then Err.Raise 382
    cboCombo.SelText() = New_SelText
    PropertyChanged "SelText"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,Sorted
Public Property Get Sorted() As Boolean
Attribute Sorted.VB_Description = "Indicates whether the elements of a control are automatically sorted alphabetically."
    Sorted = cboCombo.Sorted
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,Style
Public Property Get Style() As Integer
Attribute Style.VB_Description = "Returns/sets a value that determines the type of control and the behavior of its list box portion."
    Style = cboCombo.Style
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,Text
Public Property Get Text() As String
Attribute Text.VB_Description = "Returns/sets the text contained in the control."
    Text = cboCombo.Text
End Property

Public Property Let Text(ByVal New_Text As String)
    cboCombo.Text() = New_Text
    PropertyChanged "Text"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,ToolTipText
Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
    ToolTipText = cboCombo.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
    cboCombo.ToolTipText() = New_ToolTipText
    PropertyChanged "ToolTipText"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,TopIndex
Public Property Get TopIndex() As Integer
Attribute TopIndex.VB_Description = "Returns/sets which item in a control is displayed in the topmost position."
    TopIndex = cboCombo.TopIndex
End Property

Public Property Let TopIndex(ByVal New_TopIndex As Integer)
    If Ambient.UserMode = False Then Err.Raise 382
    cboCombo.TopIndex() = New_TopIndex
    PropertyChanged "TopIndex"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cboCombo,cboCombo,-1,WhatsThisHelpID
Public Property Get WhatsThisHelpID() As Long
Attribute WhatsThisHelpID.VB_Description = "Returns/sets an associated context number for an object."
    WhatsThisHelpID = cboCombo.WhatsThisHelpID
End Property

Public Property Let WhatsThisHelpID(ByVal New_WhatsThisHelpID As Long)
    cboCombo.WhatsThisHelpID() = New_WhatsThisHelpID
    PropertyChanged "WhatsThisHelpID"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get LimitToList() As Boolean
Attribute LimitToList.VB_Description = "A flag indicating whether the user can enter values that are not in the list of items"
    LimitToList = m_LimitToList
End Property

Public Property Let LimitToList(ByVal New_LimitToList As Boolean)
    m_LimitToList = New_LimitToList
    PropertyChanged "LimitToList"
End Property

Private Sub UserControl_Initialize()
  
  lIndex = -1

End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_LimitToList = m_def_LimitToList
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
Dim Index As Integer

    cboCombo.BackColor = PropBag.ReadProperty("BackColor", &H80000005)
    cboCombo.ForeColor = PropBag.ReadProperty("ForeColor", &H80000008)
    cboCombo.Enabled = PropBag.ReadProperty("Enabled", True)
    Set cboCombo.Font = PropBag.ReadProperty("Font", Ambient.Font)
    cboCombo.Appearance = PropBag.ReadProperty("Appearance", 1)
    cboCombo.Locked = PropBag.ReadProperty("Locked", False)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    cboCombo.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    cboCombo.Text = PropBag.ReadProperty("Text", "Combo1")
    cboCombo.ToolTipText = PropBag.ReadProperty("ToolTipText", "")
    cboCombo.WhatsThisHelpID = PropBag.ReadProperty("WhatsThisHelpID", 0)
    m_LimitToList = PropBag.ReadProperty("LimitToList", m_def_LimitToList)
End Sub

Private Sub UserControl_Resize()
  
  If Height <> cboCombo.Height Then Height = cboCombo.Height
  cboCombo.Move 0, 0, ScaleWidth

End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
Dim Index As Integer

    Call PropBag.WriteProperty("BackColor", cboCombo.BackColor, &H80000005)
    Call PropBag.WriteProperty("ForeColor", cboCombo.ForeColor, &H80000008)
    Call PropBag.WriteProperty("Enabled", cboCombo.Enabled, True)
    Call PropBag.WriteProperty("Font", cboCombo.Font, Ambient.Font)
    Call PropBag.WriteProperty("Appearance", cboCombo.Appearance, 1)
    Call PropBag.WriteProperty("Locked", cboCombo.Locked, False)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", cboCombo.MousePointer, 0)
    Call PropBag.WriteProperty("Text", cboCombo.Text, "Combo1")
    Call PropBag.WriteProperty("ToolTipText", cboCombo.ToolTipText, "")
    Call PropBag.WriteProperty("WhatsThisHelpID", cboCombo.WhatsThisHelpID, 0)
    Call PropBag.WriteProperty("LimitToList", m_LimitToList, m_def_LimitToList)
End Sub

