<%
   Option Explicit
   ' We'll be using these variables...
   Dim objBank, strProblem
   Dim lngCardID, intBankID, intInvalidCount

   ' Do we want to process the login?
   If Request("processlogin") <> "" Then

      ' Create an instance of the Bank...
      Set objBank = Server.CreateObject("Bank_Bus.Bank")

      ' Do we have a valid card?
      strProblem = ""
      If Len(Request("cardnumber")) = 12 Then

         ' Is the card number all numeric?
         If IsNumeric(Request("cardnumber")) Then

            ' Get hold of the card id and bank id...
            lngCardID = objBank.GetCardID(Request.Form("cardnumber"))
            intBankID = objBank.GetBankID(Request.Form("cardnumber"))

            ' Verify the user...
            If objBank.VerifyLogin(intBankID, lngCardID, _
               Request("password"), intInvalidCount) = True Then

               ' Sign them in the logic...
               Session("BankID") = intBankID
               Session("CardID") = lngCardID

            Else
               strProblem = _
                  "Your password does not appear to be valid."
            End if

         Else
            strProblem = "Enter only numbers into the card number."
         End If

      Else
         strProblem = _
            "You must enter exactly 12 digits for the card number."
      End If

   End If
%>
<html>
   <head>
      <title>Wrox Online Banking Application</title>
   </head>
   <body>
      <font size=3><b>Welcome to WROBA</b></font>
      <%
         ' Are we logged in?
         If IsEmpty(Session("BankID")) Then
      %>            

         <!-- Create a login form... -->
         <form action="default.asp" method=post>
 <%
            ' Did we have a problem?
            If strProblem <> "" Then
               Response.Write "<font color=#800000>"
               Response.Write strProblem
               Response.Write "</font>"
            End If
         %>
         <!-- Add the controls to the form... -->
         Card Number: <input type=text name=cardnumber><br>
         Password: <input type=password name=password><br>
         <input type=submit value="Login">
         <input type=hidden name="processlogin" value=1>

         <!-- End the form... -->
         </form>
      <% Else %>
      <% ' What activity do we want to undertake? 
      Select Case Request("action") %>
      
       <% Case "transfer" %>
   <b>Transfer Funds</b><br><br>
   <% If Request.Form("source") = "" Or Request.Form("target") = "" Then %>

      <!-- Present the transfer form -->
      <form action="<%=Request.ServerVariables("script_name")%>" method=post>
      Transfer from: <select name=source>
      <option value="">(Select)</option>
      <% AddAccountList %>
      </select><br>
      Transfer to: <select name=target>
      <option value="">(Select)</option>
      <% AddAccountList %>
      </select><br>
      Amount: <input type=text name="amount" value="0"><br>
      <input type=submit value="Transfer">
      <input type=hidden name="action" value="<%=Request("action")%>">
      </form>

   <% Else 
    ' We'll need these...
   Dim dblAmount

   ' Reset the problem string...
   strProblem = ""

   ' Did we specify two distinct accounts?
   If Request.Form("source") = Request.Form("target") Then
      strProblem = "You must specify two separate accounts."
   Else

      ' Try and convert the amount...
      dblAmount = 0
      On Error Resume Next
      dblAmount = Request.Form("amount")
      On Error Goto 0

      ' Did we get a proper amount?
      If dblAmount = 0 Then 
         strProblem = "You must specify an amount to transfer."
      End If

   End If

   ' Did we pass validation OK?
   If strProblem = "" Then

      ' Transfer the money...
      Dim objTransfer, intResult
      Set objTransfer = Server.CreateObject("Bank_Bus.Transfer")
      intResult = objTransfer.TransferFunds(Session("BankID"), _
            Request.Form("source"), Session("BankID"), _
            Request.Form("target"), dblAmount, 1, "WROBA Transfer")

      ' Render the results...
      Response.Write "<b>Result:</b> " & GetResultString(intResult)
      Response.Write "<br><br>"

      ' Render a button to go back...
      Response.Write "<a href="""
      Response.Write Request.ServerVariables("script_name")
      Response.Write """>Back</a>"

   Else
      Response.Write "<b>Funds could not be transferred...</b><br>"
      Response.Write strProblem
   End If
   
   End If %>
      
      
<% Case "view" %>
      <table cellspacing=0 cellpadding=2 border=1>
      <tr><td colspan=5><b>Transaction History</b></td></tr>
      <tr><td>Date</td>
      <td>Type</td>
      <td>Description</td>
      <td>Amount</td>
      <td>Counterparty</td></tr>
      <%
      Dim rsTransactions
      Set objBank = Server.CreateObject("Bank_Bus.Bank")
      Set rsTransactions = objBank.GetAccountHistory(Session("BankID"), _
                              Request("id"), Now)
      Do While Not rsTransactions.EOF

         ' Render the transaction...
         Response.Write "<tr>"
         Response.Write "<td>" & rsTransactions("TxDate") & "</td>"
         Response.Write "<td>" & rsTransactions("TxTypeDesc") & "</td>"
         Response.Write "<td>" & rsTransactions("TxDescription") & "</td>"
         Response.Write "<td>" & rsTransactions("TxAmount") & "</td>"
         Response.Write "<td>" & _
                     rsTransactions("CounterpartyRef") & "</td>"
         Response.Write "</tr>"

         ' Next
         rsTransactions.MoveNext

      Loop
      rsTransactions.Close
      Set rsTransactions = Nothing
      %>
      </table>
      
<br><br>
<a href="<%=Request.ServerVariables("script_name")%>?action=transfer">Transfer Funds</a><br>
      
      
      <!-- add a link to go back... -->
      <br>
      <a href="<%=Request.ServerVariables("script_name")%>">Back</a>
         <% Case Else %>
         <table cellspacing=0 cellpadding=2 border=1>
         <tr><td colspan=4><b>Your Accounts</b></td></tr>
         <tr><td>Name</td>
         <td>Balance</td>
         <td>Daily Remaining</td>
         <td>Overdraft Limit</td></tr>
         <%
            ' Get a list of the accounts...
            Dim rsAccounts
            Set objBank = Server.CreateObject("Bank_Bus.Bank")
            Set rsAccounts = objBank.GetAccounts(Session("BankID"), _
                              Session("CardID"))
            Do While Not rsAccounts.EOF

               ' Render the account...
               Response.Write "<tr>"
               Response.Write "<td><a href="""
               Response.Write Request.ServerVariables("script_name") & _
                     "?action=view&id=" & rsAccounts("accountid")
               Response.Write """>"
               Response.Write rsAccounts("AccountTypeDesc") 
               Response.Write "</a></td>"
               Response.Write "<td>" & _
                     rsAccounts("Balance") & "</td>"
               Response.Write "<td>" & _
                     rsAccounts("DailyRemaining") & "</td>"
               Response.Write "<td>" & _
                     rsAccounts("OverdraftLimit") & "</td>"
               Response.Write "</tr>"

               ' Next...
               rsAccounts.MoveNext
               response.write "<br>"

            Loop
            rsAccounts.Close
            Set rsAccounts = Nothing
         %>
         </table>
         <br><br>

   <% End Select %>
      <% End If %>
   <%
   Function GetResultString(intResult)
      Select Case intResult
         Case 0
            GetResultString = "Success"
         Case 1
            GetResultString = "Daily limit exceeded"
         Case 2
            GetResultString = "Not enough funds"
         Case Else
            GetResultString = "Unknown Error (" & intResult & ")"
      End Select
   End Function
   
   Sub AddAccountList

      Dim objBank, rsAccounts
      Set objBank = Server.CreateObject("Bank_Bus.Bank")
      Set rsAccounts = objBank.GetAccounts(Session("BankID"), _
                              Session("CardID"))
      Do While Not rsAccounts.EOF

         ' Render...
         Response.Write "<option value="""
         Response.Write rsAccounts("AccountId") 
         Response.Write """>"
         Response.Write rsAccounts("AccountTypeDesc") 
         Response.Write "</option>"

         ' Next
         rsAccounts.MoveNext

      Loop
      rsAccounts.Close
      Set rsAccounts = Nothing
      Set objBank = Nothing

   End Sub
%>   
      
      
   </body>
</html>