VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Parser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'CLass Parser
    Implements Command
    Private stk As Stack
    Private actionList As Collection
    Private kdata As KidData
    Private dat As Data
    Private ptable As ListBox
    Private chn As Chain
    
    Public Sub init(ByVal line As String, ByVal k As KidData, ByVal pt As ListBox)
        Set stk = New Stack
        setData k, pt
        
        Set actionList = New Collection  'actions accumulate here
        buildStack (line)
        buildChain    'construct interpreter chain
    End Sub
    '----------------------------------------
    Private Sub buildStack(ByVal line As String)
        'parse input tokens and build stack
        Dim tok As New Tokenizer
        tok.init line
        While (tok.hasMoreElements())
            Dim token As ParseObject
            token = tokenize(tok.nextToken())
            'Try
                stk.push (token)
            'Catch e As exception     'catches null
            'End Try
        Wend
    End Sub
    '----------------------------------------
    Private Sub buildChain()
        Set chn = New VarVarParse  'start of chain
        Dim vmvp As New VarMultVarParse
        chn.addChain vmvp
        
        Dim mvvp As New MultVarVarParse
        Set chn = mvvp
        chn.addChain mvvp
        
        Dim vrvp As New VerbMultVarParse
        Set chn = vrvp
        chn.addChain (vrvp)
        Dim vvp As New VerbVarParse
        Set chn = vvp
        chn.addChain vvp
        Dim va As New VerbAction
        va.init actionList
        
        chn.addChain (va)
    End Sub
    '----------------------------------------
    Public Sub setData(ByVal k As KidData, ByVal pt As ListBox)
       Set dat = New Data
       dat.init k.getData()
        Set ptable = pt
    End Sub
    '--------------------------------------
    Public Function tokenize(ByVal s As String) As ParseObject
        Dim obj As ParseObject
        Dim typ As Integer
        'Try
            Set obj = getVerb(s)
            typ = obj.getType 'this will throw null exception
            
        'Catch e As NullReferenceException
            'Set obj = getVar(s)
            
        'End Try
        
        Set tokenize = obj
    End Function
    '----------------------------------------
    Private Function getVerb(ByVal s As String) As ParseVerb
        Dim v As New ParseVerb
        v.init s ', dat, ptable
        If (v.isLegal()) Then
            
            Set getVerb = v.getVerb(s)
        Else
            Set getVerb = Nothing
        End If
    End Function
    '----------------------------------------
    Private Function getVar(ByVal s As String) As ParseVar
        Dim v As New ParseVar
        v.init (s)
        If (v.isLegal()) Then
            Set getVar = v
        End If
    End Function
    
Private Sub Command_Execute()
  Dim i As Integer
  Dim cmd As Command
        While (stk.hasMoreElements())
            chn.sendToChain (stk)
        Wend
        'now execute the verbs
        For i = 0 To actionList.Count - 1
            Dim v As verb
            v = actionList(i)
            v.setData dat, ptable
            Set cmd = v
            cmd.Execute
        Next i
End Sub
