Imports System.Drawing
Imports System.WinForms
Imports System.ComponentModel
Imports System.Collections

Public Class BarPlot
    Inherits System.WinForms.Form
    Private xmin As Single, xmax As Single
    Protected xfactor As Single, xpmin As Single, xpmax As Single
    Protected ymin As Single, ymax As Single
    Protected yfactor As Single, ypmin As Single, ypmax As Single
    Private w As Integer, h As Integer
    Private colors As arraylist
    Protected x() As Single, y() As Single
    Protected bPen As Pen
    Protected hasData As Boolean
    Const max As Single = 1E+38
    '-----    
    Public Sub New()
        MyBase.New()
        BarPlot = Me
        InitializeComponent()
    End Sub
    '-----    
    'Form overrides dispose to clean up the component list.
    Public Overrides Sub Dispose()
        MyBase.Dispose()
        components.Dispose()
    End Sub
    '----- 
    Public Sub setPenColor(ByVal c As Color)
        bpen = New Pen(c)
    End Sub
    '----- 
    Private Sub findBounds()
        Dim i As Integer
        xmin = max
        xmax = -max
        ymin = max
        ymax = -max
        
        For i = 0 To x.Length - 1
            If x(i) > xmax Then xmax = x(i)
            If x(i) < xmin Then xmin = x(i)
            If y(i) > ymax Then ymax = y(i)
            If y(i) < ymin Then ymin = y(i)
        Next i
        
    End Sub
    '-----    
    Public Overridable Sub set_Bounds()
        findBounds()
        'compute scaling factors
        h = Pic.Height
        w = Pic.Width
        xfactor = 0.8F * w / (xmax - xmin)
        xpmin = 0.05F * w
        xpmax = w - xpmin
        
        yfactor = 0.9F * h / (ymax - ymin)
        ypmin = 0.05F * h
        ypmax = h - ypmin
        'create array of colors for bars
        colors = New arraylist()
        colors.Add(New SolidBrush(Color.Red))
        colors.Add(New SolidBrush(color.Green))
        colors.Add(New SolidBrush(color.Blue))
        colors.Add(New SolidBrush(Color.Magenta))
        colors.Add(New SolidBrush(color.Yellow))
    End Sub
    '-----    
    Public Function calcx(ByVal xp As Single) As Integer
        Dim ix As Integer
        ix = ((xp - xmin) * xfactor + xpmin).ToInt16
        Return ix
    End Function
    '-----    
    Public Function calcy(ByVal yp As Single) As Integer
        Dim iy As Integer
        yp = ((yp - ymin) * yfactor).ToInt16
        iy = (ypmax - yp).ToInt16
        Return iy
    End Function
    '-----    
    Public Sub plot(ByVal xp() As Single, ByVal yp() As Single)
        x = xp
        y = yp
        set_Bounds()    'compute scaling factors
        hasData = True
        pic.Refresh()
    End Sub
#Region " Windows Form Designer generated code "
    
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container
    Private WithEvents Pic As System.WinForms.PictureBox
    
    Dim WithEvents BarPlot As System.WinForms.Form
    
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.Pic = New System.WinForms.PictureBox()
        
        '@design Me.TrayHeight = 0
        '@design Me.TrayLargeIcon = False
        '@design Me.TrayAutoArrange = True
        Pic.BorderStyle = System.WinForms.BorderStyle.Fixed3D
        Pic.BackColor = System.Drawing.SystemColors.ActiveCaptionText
        Pic.Location = New System.Drawing.Point(24, 24)
        Pic.Size = New System.Drawing.Size(256, 216)
        Pic.TabIndex = 0
        Pic.TabStop = False
        
        Me.Text = "BarPlot"
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        
        Me.Controls.Add(Pic)
    End Sub
    
#End Region
    '-----    
    Public Overridable Sub Pic_Paint(ByVal sender As Object, ByVal e As System.WinForms.PaintEventArgs) Handles Pic.Paint
        Dim g As Graphics = e.Graphics
        Dim i, ix, iy As Integer
        Dim br As Brush
        If hasData Then
            For i = 0 To x.Length - 1
                ix = calcx(x(i))
                iy = calcy(y(i))
                br = CType(colors(i), brush)
                g.FillRectangle(br, ix, h - iy, 20, iy)
            Next
        End If
    End Sub
End Class
