VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 2  'RequiresTransaction
END
Attribute VB_Name = "SalesOrderItemT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3748FC760391"
'The transact data centric SalesOrderItem class.
Option Explicit

Implements MTxAS.ObjectControl

'##ModelId=374C45120316
Private Const mcClassName As String = "DCSalesOrder.SalesOrderItemT"
'##ModelId=374C45120399
Private Const mcObjectError As Long = vbObjectError + &H1050

'##ModelId=374C45130047
Private mObjCtx As MTxAS.ObjectContext

'Save a Sales Order Item record.
'##ModelId=374905B801FE
Public Sub Save(ByVal OrderID As Long, ByVal ItemData As String)
    On Error GoTo ErrHandler
    
    Dim ProductID As Long
    Dim Price As Currency
    Dim Quantity As Integer
    Dim cn As ADODB.Connection
    Dim SQLQuery As String
    
    Deserialize ItemData, ProductID, Price, Quantity
    SQLQuery = "INSERT INTO [Order Details] " & _
                "(OrderID, ProductID, UnitPrice, Quantity) " & _
                "VALUES " & _
                "(" & CStr(OrderID) & ", " & CStr(ProductID) & ", " & _
                CStr(Price) & ", " & CStr(Quantity) & ")"
                
    Set cn = New ADODB.Connection
    With cn
        .Open ConnString
        .Execute SQLQuery, , adExecuteNoRecords
        .Close
    End With
    
    mObjCtx.SetComplete
    
FuncExit:
    Exit Sub
    
ErrHandler:
    Err.Raise mcObjectError + 1, mcClassName, Err.Description
    mObjCtx.SetAbort
    Resume FuncExit
End Sub

'Delete on or more Sales Order Item record by Order ID and Product ID.  If
'Product ID is not given, it deletes all items in the order.
'##ModelId=374905F602DA
Public Sub Delete(ByVal OrderID As Long, Optional ByVal ProductID As Long = 0)
    On Error GoTo ErrHandler
    
    Dim cn As ADODB.Connection
    Dim SQLQuery As String
    
    SQLQuery = "DELETE [Order Details] " & _
                "WHERE OrderID = " & OrderID
    If ProductID <> 0 Then
        SQLQuery = SQLQuery & " AND ProductID = " & ProductID
    End If
                
    Set cn = New ADODB.Connection
    With cn
        .Open ConnString
        .Execute SQLQuery, , adExecuteNoRecords
        .Close
    End With
    
    mObjCtx.SetComplete
    
FuncExit:
    Exit Sub
    
ErrHandler:
    Err.Raise mcObjectError + 2, mcClassName, Err.Description
    mObjCtx.SetAbort
    Resume FuncExit
End Sub


'Deserialize the Sales Order Item data sent to the Save method.  The data is
'decomposed to the four ByRef parameters: ProductID, Price, and Quantity.
'##ModelId=374910D000EA
Private Sub Deserialize(Data As String, ProductID As Long, Price As Currency, Quantity As Integer)
    On Error GoTo ErrHandler
    
    Dim PropBag As PropertyBag
    Dim ByteArr() As Byte
    
    ByteArr = Data
    Set PropBag = New PropertyBag
    With PropBag
        .Contents = ByteArr
        ProductID = .ReadProperty("ProductID")
        Price = .ReadProperty("Price")
        Quantity = .ReadProperty("Quantity")
    End With
    
FuncExit:
    Set PropBag = Nothing
    Exit Sub
    
ErrHandler:
    Err.Raise mcObjectError + 11, mcClassName, Err.Description
    mObjCtx.SetAbort
    Resume FuncExit
End Sub

'##ModelId=374C451401B1
Private Sub ObjectControl_Activate()
    On Error GoTo ErrHandler
    Set mObjCtx = MTxAS.GetObjectContext
    
FuncExit:
    Exit Sub
    
ErrHandler:
    Err.Raise mcObjectError, mcClassName, Err.Description
    Resume FuncExit
End Sub

'##ModelId=374C4514020B
Private Function ObjectControl_CanBePooled() As Boolean
    On Error Resume Next
    ObjectControl_CanBePooled = False
End Function

'##ModelId=374C4514026F
Private Sub ObjectControl_Deactivate()
    On Error Resume Next
    Set mObjCtx = Nothing
End Sub


